-- functions.lua
-- Written By Habna


function AddCallback(object, event, callback)
	--write("Add Event: " .. tostring(event));
	--write("Add Callback: " .. tostring(callback));
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function RemoveCallback(object, event, callback)
	--write("Remove Event: " .. tostring(event));
	--write("Remove Callback: " .. tostring(callback));
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end


--**v Create a ToolTip Window v**
function createToolTipWin( xOffset, yOffset, xSize, ySize, side, header, text1, text2, text3 )
	local txt = {text1, text2, text3};
	ToolTipWin = Turbine.UI.Window();
	ToolTipWin:SetSize( xSize, ySize );
	--ToolTipWin:SetBackColor( Color["red"] ); -- Debug purpose
	--ToolTipWin:SetMouseVisible( false );
	--ToolTipWin:SetZOrder( 15 );
	ToolTipWin.xOffset = xOffset;
	ToolTipWin.yOffset = yOffset;

	--**v Top left corner v**
	topLeftCorner = Turbine.UI.Control();
	topLeftCorner:SetParent( ToolTipWin );
	topLeftCorner:SetPosition( 0, 0 );
	topLeftCorner:SetSize( 15, 12 );
	if side == "left" then topLeftCorner:SetBackground( resources.LeftBubble_TopLeftCorner.Background );
	elseif side == "right" then	topLeftCorner:SetBackground( resources.RightBubble_TopLeftCorner.Background ); end
	--**^
	--**v Mid Left v**
	midLeft = Turbine.UI.Control();
	midLeft:SetParent( ToolTipWin );
	midLeft:SetPosition( 0, 12 );
	midLeft:SetSize( 15, ToolTipWin:GetHeight() - 12 );
	midLeft:SetBackground( resources.Bubble_MidLeft.Background );
	--**^
	--**v Bottom Left Corner v**
	botLeftCorner = Turbine.UI.Control();
	botLeftCorner:SetParent( ToolTipWin );
	botLeftCorner:SetPosition( 0, ToolTipWin:GetHeight() - 12 );
	botLeftCorner:SetSize( 15, 12 );
	botLeftCorner:SetBackground( resources.Bubble_BotLeftCorner.Background );
	--**^
	--**v Top v**
	TopBar = Turbine.UI.Control();
	TopBar:SetParent( ToolTipWin );
	TopBar:SetPosition( 15, 0 );
	TopBar:SetSize( ToolTipWin:GetWidth() - 15, 12 );
	TopBar:SetBackground( resources.Bubble_Top.Background );
	--**^
	--**v Middle v**
	MidMid = Turbine.UI.Control();
	MidMid:SetParent( ToolTipWin );
	MidMid:SetPosition( 15, 12 );
	MidMid:SetSize( ToolTipWin:GetWidth() - 15, ToolTipWin:GetHeight() - 12 );
	MidMid:SetBackground( resources.Bubble_Mid.Background );
	--**^
	--**v Bottom v**
	BotBar = Turbine.UI.Control();
	BotBar:SetParent( ToolTipWin );
	BotBar:SetPosition( 15, ToolTipWin:GetHeight() - 12 );
	BotBar:SetSize( ToolTipWin:GetWidth() - 5, 12 );
	BotBar:SetBackground( resources.Bubble_Bot.Background );
	--**^
	--**v Top right corner v**
	topRightCorner = Turbine.UI.Control();
	topRightCorner:SetParent( ToolTipWin );
	topRightCorner:SetPosition( ToolTipWin:GetWidth() - 15, 0 );
	topRightCorner:SetSize( 15, 12 );
	if side == "left" then topRightCorner:SetBackground( resources.LeftBubble_TopRightCorner.Background );
	elseif side == "right" then topRightCorner:SetBackground( resources.RightBubble_TopRightCorner.Background ); end
	--**^
	--**v Mid Right v**
	midRight = Turbine.UI.Control();
	midRight:SetParent( ToolTipWin );
	midRight:SetPosition( ToolTipWin:GetWidth() - 15, 12 );
	midRight:SetSize( 15, ToolTipWin:GetHeight() - 12 );
	midRight:SetBackground( resources.Bubble_MidRight.Background );
	--**^
	--**v Bottom right corner v**
	botRightCorner = Turbine.UI.Control();
	botRightCorner:SetParent( ToolTipWin );
	botRightCorner:SetPosition( ToolTipWin:GetWidth() - 15, ToolTipWin:GetHeight() - 12 );
	botRightCorner:SetSize( 15, 12 );
	botRightCorner:SetBackground( resources.Bubble_BotRightCorner.Background );
	--**^
	--**v Text in Header v**
	lblheader = Turbine.UI.Label();
	lblheader:SetParent( ToolTipWin );
	lblheader:SetPosition( 10, 10 );
	lblheader:SetSize( xSize, ySize );
	lblheader:SetForeColor( Color["blue"] );
	lblheader:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	lblheader:SetText( header );
	--**^
	
	local YPos = 25;
	
	--**v Text v**
	for i = 1, 3 do
		local lbltext = Turbine.UI.Label();
		lbltext:SetParent( ToolTipWin );
		lbltext:SetPosition( 10, YPos );
		lbltext:SetSize( xSize, 15 );
		lbltext:SetForeColor( Color["black"] );
		lbltext:SetFont(Turbine.UI.Lotro.Font.Verdana14);
		lbltext:SetText( txt[i] );
		YPos = YPos + 15;
	end
	--**^

	return ToolTipWin;
end

-- Legend
-- ( offsetX, offsetY, width, height, bubble side, header text, text1, text2, text3, text4 )
function ShowToolTipWin( ToShow )
	local bblTo, x, y, w = "left", 0, -17, 0;
	local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
	
	w = 235;
	if TBLocale == "fr" then w = 300; end
	if TBLocale == "de" then
		if ToShow == "DI" then w = 225;
		elseif ToShow == "PIcon" then w = string.len(L["PIICON"] .. PlayerRaceIs .. PlayerClassIs) * 7.9; --w = 245;
		else w = 210;
		end
	end

	if ToShow == "MoneyG" then -- Money infos Gold
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 75, bblTo, L["MGh"], L["EIt1"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "MoneyS" then -- Money infos Silver
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 75, bblTo, L["MSh"], L["EIt1"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "MoneyC" then -- Money infos Copper
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 75, bblTo, L["MCh"], L["EIt1"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "DP" then -- Destiny points
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["DPh"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "SP" then -- Shards
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["SPh"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "SM" then -- Skirmish marks
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["SMh"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "MP" then -- Medallions
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["MPh"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "SL" then -- Seals
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["SLh"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "CP" then -- Commendations
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["CPh"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "Bag" then --Bag infos
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 75, bblTo, L["BIh"], L["BIt1"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "PIcon" then -- Player class
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["PIICON"] .. PlayerRaceIs .. PlayerClassIs, L["EIt2"], L["EIt3"] );
	elseif ToShow == "PLvl" then -- Player level
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["PILVL"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "PName" then -- Player name
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["PINAME"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "EI" then -- Equipment infos
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 75, bblTo, L["EIh"], L["EIt1"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "DI" then -- Durability infos
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 75, bblTo, L["DIh"], L["EIt1"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "PL" then -- Player Location
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["PLh"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "GT" then -- Game Time
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 75, bblTo, L["GTh"], L["EIt1"], L["EIt2"], L["EIt3"] );
	end

	ToolTipWin:SetPosition( mouseX - ToolTipWin.xOffset, mouseY - ToolTipWin.yOffset);
	ToolTipWin:SetVisible( true );
end
--**^
--**v Update money on TitanBar v**
function UpdateMoney()
	local money = PlayerAtt:GetMoney();
	local cp = math.fmod( money, 100 ); -- Copper
	money = ( money - cp) / 100;
	local sp = math.fmod( money, 1000 ); -- Silver
	local gp = ( money - sp ) / 1000; -- Gold
	
	MI["GLbl"]:SetText( string.format("%.0f", gp) );
	MI["SLbl"]:SetText( string.format("%.0f", sp) );
	MI["CLbl"]:SetText( string.format("%.0f", cp) );

	SaveCharacterMoney();

	if _G.STM then --Show Total Money of all character on TitanBar Money control.
		MI["GLbl"]:SetText( string.format("%.0f", GoldTot) );
		MI["SLbl"]:SetText( string.format("%.0f", SilverTot) );
		MI["CLbl"]:SetText( string.format("%.0f", CopperTot) );
	end

	MI["GLbl"]:SetSize( string.len(MI["GLbl"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght
	MI["SLbl"]:SetSize( string.len(MI["SLbl"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght
	MI["CLbl"]:SetSize( string.len(MI["CLbl"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght

	AjustIcon( "MI" );
end
--**^
--**v Update destiny point currency on TitanBar v**
function UpdateDestinyPoints()
	DP["Lbl"]:SetText( PlayerAtt:GetDestinyPoints() );
	DP["Lbl"]:SetSize( string.len(DP["Lbl"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght
	
	AjustIcon( "DP" );
end
--**^
--**v Update Shards currency on TitanBar v**
function UpdateShards()
	SP["Lbl"]:SetText( GetCurrency( pwShard ) );
	SP["Lbl"]:SetSize( string.len(SP["Lbl"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght
	
	AjustIcon( "SP" );
end
--**^
--**v Update Shards currency on TitanBar v**
function UpdateMarks()
	SM["Lbl"]:SetText( GetCurrency( pwMark ) );
	SM["Lbl"]:SetSize( string.len(SM["Lbl"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght
	
	AjustIcon( "SM" );
end
--**^
--**v Update Medallions currency on TitanBar v**
function UpdateMedallions()
	MP["Lbl"]:SetText( GetCurrency( pwMedallion ) );
	MP["Lbl"]:SetSize( string.len(MP["Lbl"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght

	AjustIcon( "MP" );
end
--**^
--**v Update Shards currency on TitanBar v**
function UpdateSeals()
	SL["Lbl"]:SetText( GetCurrency( pwSeal ) );
	SL["Lbl"]:SetSize( string.len(SL["Lbl"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght
	
	AjustIcon( "SL" );
end
--**^
--**v Update Commendations currency on TitanBar v**
function UpdateCommendations()
	CP["Lbl"]:SetText( GetCurrency( pwCommendation ) );
	CP["Lbl"]:SetSize( string.len(CP["Lbl"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght
	
	AjustIcon( "CP" );
end
--**^
--**v Update backpack infos on TitanBar v**
function UpdateBackpackInfos()
	local max = Backpack:GetSize();
	local freeslots = 0;

	for i = 1, max do
		if ( Backpack:GetItem( i ) == nil ) then freeslots = freeslots + 1; end
	end

	BI["Lbl"]:SetText( max - freeslots .. "/" .. max );
	BI["Lbl"]:SetSize( string.len(BI["Lbl"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght

	--Change bag icon with capacity
	local BagIcon = nil;
	local usedslots = max - freeslots;
	local bi = math.round(( usedslots / max ) * 100);

	if bi >= 0 and bi <= 15 then BagIcon = 0x41008113; end-- 0% to 15% Full bag
	if bi >= 16 and bi <= 30 then BagIcon = 0x41008114; end-- 16% to 30% Full bag
	if bi >= 31 and bi <= 75 then BagIcon = 0x41008115; end-- 31% to 75% Full bag
	if bi >= 76 and bi <= 99 then BagIcon = 0x41008111; end-- 75% to 99% Full bag
	if bi == 100 then BagIcon = 0x41008112; end-- 100% Full bag
	--if bi >= 101 then BagIcon = 0x41007ecf; end-- over loaded bag
	
	BI["Icon"]:SetBackground( BagIcon );

	AjustIcon( "BI" );
end
--**^
--**v Update player infos on TitanBar v**
function UpdatePlayersInfos()
	PlayerRaceIs = Player:GetRace();

	--Free people race
	if PlayerRaceIs == 0 then PlayerRaceIs = ""; -- Undefined
	elseif PlayerRaceIs == 65 then PlayerRaceIs = L["Elf"];
	elseif PlayerRaceIs == 23 then PlayerRaceIs = L["Man"];
	elseif PlayerRaceIs == 73 then PlayerRaceIs = L["Dwarf"];
	elseif PlayerRaceIs == 81 then PlayerRaceIs = L["Hobbit"]; end

	--Monster play race
	if PlayerRaceIs == 7 then PlayerRaceIs = ""; end

	PlayerClassIs = Player:GetClass();

	-- 0x41008500 (red eye) 32x32

	--Free People Class
	if PlayerClassIs == 23 then PlayerClassIs = L["Guardian"]; PlayerIconCodeIs = "0x41007dd8"; end
	if PlayerClassIs == 24 then PlayerClassIs = L["Captain"]; PlayerIconCodeIs = "0x41007dd7"; end
	if PlayerClassIs == 31 then PlayerClassIs = L["Minstrel"]; PlayerIconCodeIs = "0x41007dd6"; end
	if PlayerClassIs == 40 then PlayerClassIs = L["Burglar"]; PlayerIconCodeIs = "0x41007ddb"; end
	if PlayerClassIs == 162 then PlayerClassIs = L["Hunter"]; PlayerIconCodeIs = "0x41007dda"; end
	if PlayerClassIs == 172 then PlayerClassIs = L["Champion"]; PlayerIconCodeIs = "0x41007ddc"; end
	if PlayerClassIs == 185 then PlayerClassIs = L["Lore-Master"]; PlayerIconCodeIs = "0x41007dd9"; end
	if PlayerClassIs == 193 then PlayerClassIs = L["Rune-Keeper"]; PlayerIconCodeIs = "runekeeper"; end --Using my icon, need in-game one thought
	if PlayerClassIs == 194 then PlayerClassIs = L["Warden"]; PlayerIconCodeIs = "warden"; end --Using my icon, need in-game one thought

	--Monster Play Class
	if PlayerClassIs == 52 then PlayerClassIs = L["Warleader"]; PlayerIconCodeIs = "0x41007dde"; end
	if PlayerClassIs == 71 then PlayerClassIs = L["Reaver"]; PlayerIconCodeIs = "0x41007ddd"; end
	if PlayerClassIs == 126 then PlayerClassIs = L["Stalker"]; PlayerIconCodeIs = "0x41007de1"; end
	if PlayerClassIs == 127 then PlayerClassIs = L["Weaver"]; PlayerIconCodeIs = "0x41007de0"; end
	if PlayerClassIs == 128 then PlayerClassIs = L["Defiler"]; PlayerIconCodeIs = "defiler";  end --Using my icon, need in-game one thought
	if PlayerClassIs == 179 then PlayerClassIs = L["Blackarrow"]; PlayerIconCodeIs = "0x41007ddf"; end
	
	if PlayerIconCodeIs == "default" then PI["Icon"]:SetBackground( resources.Ring.Icon );
	elseif PlayerIconCodeIs == "runekeeper" then PI["Icon"]:SetBackground( resources.RuneKeeper.Icon );
	elseif PlayerIconCodeIs == "warden" then PI["Icon"]:SetBackground( resources.Warden.Icon );
	elseif PlayerIconCodeIs == "defiler" then PI["Icon"]:SetBackground( resources.Defiler.Icon );
	else PI["Icon"]:SetBackground( tonumber(PlayerIconCodeIs) ); end
	
	PI["Lvl"]:SetText( Player:GetLevel() );
	PI["Lvl"]:SetSize( string.len(PI["Lvl"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght
	PI["Name"]:SetPosition( PI["Lvl"]:GetLeft() + PI["Lvl"]:GetWidth(), 0 );
	--PI["Name"]:SetText( "OneBigLongCharacterName" ); --Debug purpose
	PI["Name"]:SetText( Player:GetName() );
	PI["Name"]:SetSize( string.len(PI["Name"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght

	AjustIcon( "PI" );
end
--**^
--**v Update equipment infos on TitanBar v**
function UpdateEquipsInfos()
	GetEquipmentInfos();

	CalculateAllItemsScore();

	EI["Lbl"]:SetText( itemTotScore );
	EI["Lbl"]:SetSize( string.len(EI["Lbl"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght

	AjustIcon( "EI" );

	if ShowDurabilityInfos then UpdateDurabilityInfos(); end
end
--**^

function ChangeWearState(value)
	-- Set new wear state in table
	itemEquip[value].WearState = PlayerEquipment:GetItem( EquipSlots[Slots[value]] ):GetWearState();

	UpdateDurabilityInfos();
end

--**v Update Player Durability infos on TitanBar v**
function UpdateDurabilityInfos()
	CalculateAllItemsDurability();
	
	--Change durability icon with %
	local DurIcon = nil;
	
	if itemsTotDurability >= 0 and itemsTotDurability <= 33 then DurIcon = 0x410e924c; end-- 0% to 33% --0x41007e29
	if itemsTotDurability >= 34 and itemsTotDurability <= 66 then DurIcon = 0x410e925c; end-- 34% to 66% --0x41007e29
	if itemsTotDurability >= 67 and itemsTotDurability <= 100 then DurIcon = 0x410e926e; end-- 67% to 100% --0x41007e28
			
	DI["Icon"]:SetBackground( DurIcon );

	itemsTotDurability = string.format( "%.0f", itemsTotDurability );
	
	DI["Lbl"]:SetText( itemsTotDurability .. "%" );
	DI["Lbl"]:SetSize( string.len(DI["Lbl"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght

	AjustIcon( "DI" );
end
--**^

--**v Update Player Location on TitanBar v**
function UpdatePlayerLoc( value )
	--write( "TitanBar: Updating Player Location");

	PL["Lbl"]:SetText( value );
	PL["Lbl"]:SetSize( string.len(PL["Lbl"]:GetText()) * TM, CTRHeight ); --Auto size with text lenght
	PL["Lbl"]:SetPosition( 5, 0 );

	PL["Ctr"]:SetSize( PL["Lbl"]:GetWidth() + 7, CTRHeight );
end
--**^
--**v Update game time on TitanBar v**
function UpdateGameTime(str)
	--write( "TitanBar: Updating Game Time");
	local currentdate = Turbine.Engine.GetDate();
	--local isDST = currentdate.IsDST; -- Day Light Savings adjustment. if True add 1h
	local currenthour = currentdate.Hour;
	local currentminute = currentdate.Minute;
	local ampm = "";

	TheTime = nil;
	TextLen = nil;
	
	if currentminute < 10 then currentminute = "0" .. currentminute; end

	if str == "st" then
		--write("Server Time");
		if _G.ShowST then
			currenthour = currenthour + _G.UserGMT;
			if currenthour < 0 then
				currenthour = 24 + currenthour;
				if currenthour == 0 then currenthour = 24; end
			elseif currenthour == 24 then
				currenthour = 24 - currenthour;
			end
		end
		--
	
		-- Convert 24h to 12h format
		if not Clock24h then
			if currenthour == 12 then ampm = "pm";
			elseif currenthour >= 13 then currenthour = currenthour - 12; ampm = "pm";
			else ampm = "am" end
		end

		_G.STime = currenthour .. ":" .. currentminute .. ampm;
		TheTime = _G.STime;
		TextLen = string.len(TheTime) * TM;
	elseif str == "gt" then
		--write("Game Time");
		-- Convert 24h to 12h format
		if not Clock24h then
			if currenthour == 12 then ampm = "pm";
			elseif currenthour >= 13 then currenthour = currenthour - 12; ampm = "pm";
			else ampm = "am" end
		end

		_G.GTime = currenthour .. ":" .. currentminute .. ampm;
		TheTime = _G.GTime;
		TextLen = string.len(TheTime) * TM;
	elseif str == "bt" then
		--write("Both Time");
		UpdateGameTime("st");
		UpdateGameTime("gt");
		TheTime = L["GTWST"] .. _G.STime .. string.char(13) .. L["GTWRT"] .. _G.GTime;
		TextLen = string.len(TheTime) * 4;
	end
	
	GT["Lbl"]:SetText( TheTime );
	GT["Lbl"]:SetSize( TextLen, CTRHeight ); --Auto size with text lenght
	GT["Ctr"]:SetSize( GT["Lbl"]:GetWidth() + 5, CTRHeight );
end
--**^

-- **v Change back color v**
function ChangeColor()
	if SetToAll then
		TB["win"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) );
		if ShowMoney then MI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowDestinyPoints then DP["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowShards then SP["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowSkirmishMarks then SM["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowMedallions then MP["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowSeals then SL["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowCommendations then CP["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowBagInfos then BI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowPlayerInfos then PI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowEquipInfos then EI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowDurabilityInfos then DI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end

		if ShowPlayerLoc then PL["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowGameTime then GT["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
	else
		TB["win"]:SetBackColor( Turbine.UI.Color(bcAlpha, bcRed, bcGreen, bcBlue) );
		if ShowMoney then MI["Ctr"]:SetBackColor( Turbine.UI.Color(MIbcAlpha, MIbcRed, MIbcGreen, MIbcBlue) ); end
		if ShowDestinyPoints then DP["Ctr"]:SetBackColor( Turbine.UI.Color(DPbcAlpha, DPbcRed, DPbcGreen, DPbcBlue) ); end
		if ShowShards then SP["Ctr"]:SetBackColor( Turbine.UI.Color(SPbcAlpha, SPbcRed, SPbcGreen, SPbcBlue) ); end
		if ShowSkirmishMarks then SM["Ctr"]:SetBackColor( Turbine.UI.Color(SMbcAlpha, SMbcRed, SMbcGreen, SMbcBlue) ); end
		if ShowMedallions then MP["Ctr"]:SetBackColor( Turbine.UI.Color(MPbcAlpha, MPbcRed, MPbcGreen, MPbcBlue) ); end
		if ShowSeals then SL["Ctr"]:SetBackColor( Turbine.UI.Color(SLbcAlpha, SLbcRed, SLbcGreen, SLbcBlue) ); end
		if ShowCommendations then CP["Ctr"]:SetBackColor( Turbine.UI.Color(CPbcAlpha, CPbcRed, CPbcGreen, CPbcBlue) ); end
		if ShowBagInfos then BI["Ctr"]:SetBackColor( Turbine.UI.Color(BIbcAlpha, BIbcRed, BIbcGreen, BIbcBlue) ); end
		if ShowPlayerInfos then PI["Ctr"]:SetBackColor( Turbine.UI.Color(PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue) ); end
		if ShowEquipInfos then EI["Ctr"]:SetBackColor( Turbine.UI.Color(EIbcAlpha, EIbcRed, EIbcGreen, EIbcBlue) ); end
		if ShowDurabilityInfos then DI["Ctr"]:SetBackColor( Turbine.UI.Color(DIbcAlpha, DIbcRed, DIbcGreen, DIbcBlue) ); end

		if ShowPlayerLoc then PL["Ctr"]:SetBackColor( Turbine.UI.Color(PLbcAlpha, PLbcRed, PLbcGreen, PLbcBlue) ); end
		if ShowGameTime then GT["Ctr"]:SetBackColor( Turbine.UI.Color(GTbcAlpha, GTbcRed, GTbcGreen, GTbcBlue) ); end
		
		if sFrom == "TitanBar" then TB["win"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "Money" then MI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "DP" then DP["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "SP" then SP["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "SM" then SM["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "MP" then MP["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "SL" then SL["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "CP" then CP["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "BI" then BI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "PI" then PI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "EI" then EI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "DI" then DI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end

		if sFrom == "PL" then PL["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "GT" then GT["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
	end
end
--**^

function LoadEquipmentTable()
	EquipSlots = {
		["Earring1"] = Turbine.Gameplay.Equipment.Earring1; --no 13
		["Earring2"] = Turbine.Gameplay.Equipment.Earring2; --no 14
		["Necklace"] = Turbine.Gameplay.Equipment.Necklace; --no 10
		["Pocket"] = Turbine.Gameplay.Equipment.Pocket; --no 15
		["Bracelet1"] = Turbine.Gameplay.Equipment.Bracelet1; --no 8
		["Bracelet2"] = Turbine.Gameplay.Equipment.Bracelet2; --no 9
		["Ring1"] = Turbine.Gameplay.Equipment.Ring1; --no 11
		["Ring2"] = Turbine.Gameplay.Equipment.Ring2; --no 12
		["Head"] = Turbine.Gameplay.Equipment.Head; --no 1
		["Shoulder"] = Turbine.Gameplay.Equipment.Shoulder; --no 6
		["Back"] = Turbine.Gameplay.Equipment.Back; --no 7
		["Chest"] = Turbine.Gameplay.Equipment.Chest; --no 2
		["Gloves"] = Turbine.Gameplay.Equipment.Gloves; --no 4
		["Legs"] = Turbine.Gameplay.Equipment.Legs; --no 3
		["Boots"] = Turbine.Gameplay.Equipment.Boots; --no 5
		["PrimaryWeapon"] = Turbine.Gameplay.Equipment.PrimaryWeapon; --no 16
		["SecondaryWeapon"] = Turbine.Gameplay.Equipment.SecondaryWeapon; --no 17
		["RangedWeapon"] = Turbine.Gameplay.Equipment.RangedWeapon; --no 18
		["Class"] = Turbine.Gameplay.Equipment.Class; --no 20
		["CraftTool"] = Turbine.Gameplay.Equipment.CraftTool; --no 19
	};

	Slots = {"Head", "Earring1", "Earring2", "Necklace", "Shoulder", "Back", "Chest", "Bracelet1", "Bracelet2",
		"Ring1", "Ring2", "Gloves", "Legs", "Boots", "Pocket", "PrimaryWeapon", "SecondaryWeapon", "RangedWeapon",
		"CraftTool", "Class"};
end

function ResetToolTipWin()
	if ToolTipWin ~= nil then
		ToolTipWin:SetVisible( false );
		ToolTipWin = nil;
	end
end

function Player:InCombatChanged(sender, args)
	if TBAutoHide == L["OPAHC"] then AutoHideCtr:SetWantsUpdates( true ); end
end

function AjustIcon(str)	
	if TBHeight > 30 then CTRHeight = 30; end --Stop ajusting icon size if TitanBar height is > 30px

	local Y = -1 - ((TBIconSize - CTRHeight) / 2);

	if str == "MI" then
		MI["GIcon"]:SetPosition( MI["GLbl"]:GetLeft() + MI["GLbl"]:GetWidth(), Y + 1 );
		MI["Ctr"]:SetSize( MI["GIcon"]:GetLeft() + TBIconSize, CTRHeight );
		
		MI["SLbl"]:SetPosition( MI["GIcon"]:GetLeft() + MI["GIcon"]:GetWidth() + 5, 0 );
		MI["SIcon"]:SetPosition( MI["SLbl"]:GetLeft() + MI["SLbl"]:GetWidth(), Y + 1 );
		MI["Ctr"]:SetSize( MI["SIcon"]:GetLeft() + TBIconSize, CTRHeight );
		
		MI["CLbl"]:SetPosition( MI["SIcon"]:GetLeft() + MI["SIcon"]:GetWidth() + 5, 0 );
		MI["CIcon"]:SetPosition( MI["CLbl"]:GetLeft() + MI["CLbl"]:GetWidth(), Y + 1);

		MI["Ctr"]:SetSize( MI["CIcon"]:GetLeft() + TBIconSize, CTRHeight );
		
		MI["GIcon"]:SetSize( TBIconSize, TBIconSize );
		MI["SIcon"]:SetSize( TBIconSize, TBIconSize );
		MI["CIcon"]:SetSize( TBIconSize, TBIconSize );
	elseif str == "DP" then
		DP["Icon"]:SetPosition( DP["Lbl"]:GetLeft() + DP["Lbl"]:GetWidth(), Y );
		DP["Ctr"]:SetSize( DP["Icon"]:GetLeft() + TBIconSize, CTRHeight );
		DP["Icon"]:SetSize( TBIconSize, TBIconSize );
	elseif str == "SP" then
		SP["Icon"]:SetPosition( SP["Lbl"]:GetLeft() + SP["Lbl"]:GetWidth() - 2, Y );
		SP["Ctr"]:SetSize( SP["Icon"]:GetLeft() + TBIconSize, CTRHeight );
		SP["Icon"]:SetSize( TBIconSize, TBIconSize );
	elseif str == "SM" then
		SM["Icon"]:SetPosition( SM["Lbl"]:GetLeft() + SM["Lbl"]:GetWidth() + 3, Y );
		SM["Ctr"]:SetSize( SM["Icon"]:GetLeft() + TBIconSize, CTRHeight );
		SM["Icon"]:SetSize( TBIconSize, TBIconSize );
	elseif str == "MP" then
		MP["Icon"]:SetPosition( MP["Lbl"]:GetLeft() + MP["Lbl"]:GetWidth() + 3, Y );
		MP["Ctr"]:SetSize( MP["Icon"]:GetLeft() + TBIconSize, CTRHeight );
		MP["Icon"]:SetSize( TBIconSize, TBIconSize );
	elseif str == "SL" then
		SL["Icon"]:SetPosition( SL["Lbl"]:GetLeft() + SL["Lbl"]:GetWidth() + 1, Y );
		SL["Ctr"]:SetSize( SL["Icon"]:GetLeft() + TBIconSize, CTRHeight );
		SL["Icon"]:SetSize( TBIconSize, TBIconSize );
	elseif str == "CP" then
		CP["Icon"]:SetPosition( CP["Lbl"]:GetLeft() + CP["Lbl"]:GetWidth() + 3, Y );
		CP["Ctr"]:SetSize( CP["Icon"]:GetLeft() + TBIconSize, CTRHeight );
		CP["Icon"]:SetSize( TBIconSize, TBIconSize );
	elseif str == "BI" then
		BI["Icon"]:SetPosition( BI["Lbl"]:GetLeft() + BI["Lbl"]:GetWidth() + 3, Y + 1 );
		BI["Ctr"]:SetSize( BI["Icon"]:GetLeft() + TBIconSize, CTRHeight );
		BI["Icon"]:SetSize( TBIconSize, TBIconSize );
	elseif str == "PI" then
		PI["Icon"]:SetPosition( PI["Name"]:GetLeft() + PI["Name"]:GetWidth(), Y );
		PI["Ctr"]:SetSize( PI["Icon"]:GetLeft() + TBIconSize, CTRHeight );
		PI["Icon"]:SetSize( TBIconSize, TBIconSize );
	elseif str == "EI" then
		EI["Icon"]:SetPosition( EI["Lbl"]:GetLeft() + EI["Lbl"]:GetWidth(), Y );
		EI["Ctr"]:SetSize( EI["Icon"]:GetLeft() + TBIconSize, CTRHeight );
		EI["Icon"]:SetSize( TBIconSize, TBIconSize );
	elseif str == "DI" then
		DI["Icon"]:SetPosition( DI["Lbl"]:GetLeft() + DI["Lbl"]:GetWidth(), Y );
		DI["Ctr"]:SetSize( DI["Icon"]:GetLeft() + TBIconSize, CTRHeight );
		DI["Icon"]:SetSize( TBIconSize, TBIconSize );
	end
end

-- For debug purpose
function ShowTableContent(table)
	for k,v in pairs(table) do
		write("key:"..tostring(k)..", value:"..tostring(v));
	end
end